PINTO(1p)

NAME
pinto - Curate a custom repository of Perl modules

VERSION
version 0.14

SYNOPSIS
  pinto --root=REPOSITORY_ROOT [global options] COMMAND [command options] [args]

DESCRIPTION
pinto is a tool for creating and managing a custom CPAN-like repository of Perl modules. The purpose of such a repository is to provide a stable, curated stack of dependencies from which you can reliably build, test, and deploy your application using the standard Perl tool chain. pinto provides various commands for gathering and managing distribution dependencies within the repository, so that you can control precisely which dependencies go into your application.

COMMANDS
pinto supports several commands that perform various operations on your repository, or report information about your repository. To get a listing of all the available commands:

  $> pinto commands

Each command has its own options and arguments. To get a brief summary:

  $> pinto help COMMAND

To see the complete manual for a command:

  $> pinto manual COMMAND

GLOBAL OPTIONS
The following options are available for all commands.

--root DIRECTORY | URI
-r DIRECTORY | URI
    Specifies the root of your repository. This is mandatory for (almost) all commands unless you set it via the "PINTO_REPOSITORY_ROOT" environment variable. The root can be the path to a local directory or an equivalent "file://" URI.

    The root can also be the URI where a pintod server is listening. Depending on your server configuration, you may need to specify the port number in the URI, which is usually 3111.

--color
--colour
--no-color
--no-colour
    Enable or disable colorized command output. By default, color is enabled unless the output is being sent to a pipe or file. Set the "PINTO_NO_COLOR" environment variable to disable color by default.

--password PASS
-p PASS
    The password to use for server authentication. This is only relevant if using a remote repository. If the PASS is "-" then you will be prompted for a password.

--quiet
-q  Report only fatal errors. This option silently overrides the "--verbose" options. Also suppresses the progress meter.

    Note: The progress meter is always suppressed when using a remote repository. This will hopefully be fixed a future release.

--username NAME
-u NAME
    The username to user for server authentication. This is only relevant if using a remote repository. Defaults to your current login.

--verbose
-v  Display more diagnostic messages. This switch can be repeated multiple times for greater effect. Diagnostic messages are always sent to STDERR.

CONFIGURATION
Each repository has a configuration file that lives inside the repository at .pinto/config/pinto.ini. This file is generated for you with default values when you create the repository. You can influence the initial value for some of the properties when you run the init command. Thereafter, you can change these properties by editing the configuraiton file directly.

The following configuration parameters are supported:

sources = URL1 [URL2 URL3 ...]
    This is a space-delimited list of the URLs for the upstream repositories that this repository will pull archives from. These can point to CPAN mirrors, minicpan mirrors, or stacks within other Pinto repositories. Pinto will search the source repositories in the order they are listed here. The default value is "http://cpan.perl.org http://backpan.perl.org".

target_perl_version = X.X.X
    Sets the default "target_perl_version" property for all new stacks. Otherwise, all new stacks will target the version of perl that you first used to create the repository. You can always configure the target perl for each stack independently by using the props command.

intermingle = 1 | 0
    If true, stacks will be allowed to "intermingle" distributions that have partially overlapping packages. This makes pinto behave like PAUSE which allows a package to remain in the index until it is replaced by a distribution containing the same package. Thus, it becomes possible to have an index that contains just "some" of the packages in a particular distribution. This typically occurrs when a package in a prior release is absent from a subsequent release. The default is false.

BEWARE: The above configuration properties are global -- they affect every stack in the repository. They also have a major affect on how the repository behaves. For these reasons, it is generally unwise to change these parameters once you have established the repository and filled it with content. If you do change them, be sure and notify your team about it. Each stack also has some stack-specific configuration properties. Those can be shown or set using the props command.

ENVIRONMENT VARIABLES
The following environment variables influence the behavior of pinto. If you have installed pinto as a stand-alone application as described in Pinto::Manual::Installing, then the best place to set these variables is in your ~/.pintorc file.

"PINTO_REPOSITORY_ROOT"
    Sets the default path or URL of the pinto repository, if the "--root" is not specified. The "--root" is required for almost all commands. So if you usually only work with one repository, then setting this can save you quite a bit of typing.

"PINTO_EDITOR"
    Sets the path to editor application that will be used to compose log messages. If not set, defaults to "VISUAL" or "EDITOR". If none of those are set, either "nano", "pico", or "vi" will be used (in that order).

"PINTO_NO_COLOR"
"PINTO_NO_COLOUR"
    If set to a true value, suppresses color in all command output.

"PINTO_PALETTE"
    A comma-separated list of exactly three color names. Any name supported by Term::ANSIColor is allowed. These will be the colors that pinto uses to colorize various output. For example:

      PINTO_PALETTE='red, light blue, green on_white'

    Listing too many or too few colors will cause an exception, as will using an invalid color name. For backward compatibility the variables "PINTO_COLORS" and "PINTO_COLOURS" can also be used (but they are deprecated).

"PINTO_USERNAME"
    Sets the default username when "--username" is not specified. This is only used for authentication with a pintod server. Defaults to your current shell username.

"PINTO_AUTHOR_ID"
    Sets the default author identity when the "--author" option is not specified (currently, only used by the add command). Defaults to your current shell username. By PAUSE convention, all author id's are forced to uppercase.

"PINTO_PAGER"
    Sets the path to the pager application that will be used to paginate output from each command. Defaults to "PAGER". If none of these are set, then no pager is used.

"PINTO_PAGER_OPTIONS"
    Sets the options that will be passed to the pager (if there is one). For example, you could use the "-R" option to instruct "less" to pass through the colors that pinto usually displays:

      export PINTO_PAGER_OPTIONS=-R

    Most pagers have their own environment variables to control their default behavior. "PINTO_PAGER_OPTIONS" gives you a way to set defaults that are specific to when you are using it with pinto.

"PINTO_DIFF_STYLE"
    Sets the default style for diff reports. Valid styles are "detailed" and "concise". The default is "concise". For commands that produce diff reports, this can be overriden with the "--diff-style" option. This variable only has effect when using a local repository.

"PINTO_DEBUG"
    If set to 1, pinto will emit more diagnostic messages to STDERR. If set to 2, pinto will emit even more diagnostic messages. This variable only has effect when using a local repository.

"PINTO_LOCKFILE_TIMEOUT"
    Sets the timeout (in seconds) for obtaining a lock on the repository. The default is 50. This variable only has effect when using a local repository.

"PINTO_STALE_LOCKFILE_TIMEOUT"
    Sets the timeout (in seconds) to consider a lock on the repository stale and expire it. The default is 0 (don't expire). This variable only has effect when using a local repository.

"PINTO_SHELL"
    Sets the path to the command pinto will use for interactive shells (like with the look command). If this is not set, pinto defaults to either "SHELL" or "COMSPEC".

SEE ALSO
pintod to allow remote access to your Pinto repository.

Pinto::Manual for general information on using Pinto.

Stratopan <http://stratopan.com> for hosting your Pinto repository in the cloud.

AUTHOR
Jeffrey Ryan Thalhammer <jeff@stratopan.com>

COPYRIGHT AND LICENSE
This software is copyright (c) 2015 by Jeffrey Ryan Thalhammer.

This is free software; you can redistribute it and/or modify it under the same terms as the Perl 5 programming language system itself.